Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj	(revision 731)
@@ -20,7 +20,7 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalOptions="/D &quot;TIXML_USE_STL&quot; /D &quot;OBA_LIB_BUILD&quot;"
+				AdditionalOptions="/D &quot;TIXML_USE_STL&quot; /D &quot;OBA_LIB_BUILD&quot;  /D &quot;IMG_LIB_BUILD&quot;"
 				Optimization="0"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Samples/Common/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;../include/IMG;../include/BBC;../include/LBBC;../include/OBA;D:\design_04_11_2005\svn\NonGTP\Boost"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Samples/Common/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;../include/IMG;../include/BBC;../include/LBBC;../include/OBA;D:\design_04_11_2005\svn\NonGTP\Boost;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_USRDLL;_MT"
 				MinimalRebuild="TRUE"
@@ -39,9 +39,9 @@
 				Name="VCLinkerTool"
 				AdditionalOptions=" /IMPLIB:&quot;..\bin\debug\$(ProjectName)_d.lib&quot; "
-				AdditionalDependencies="Ogremain_d.lib"
+				AdditionalDependencies="Ogremain_d.lib imdebug.lib"
 				OutputFile="$(OutDir)/$(ProjectName)_d.dll"
 				LinkIncremental="2"
 				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)/OgreMain/lib/Release&quot;;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\lib"
 				IgnoreDefaultLibraryNames="LIBCD;LIBCMTD"
 				GenerateDebugInformation="TRUE"
@@ -79,6 +79,6 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalOptions="/D &quot;TIXML_USE_STL&quot; /D &quot;TIXML_USE_STL&quot; /D &quot;OBA_LIB_BUILD&quot;"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;&quot;$(OGRE_PATH)/Samples/Common/include&quot;;../include/IMG;../include/BBC;../include/LBBC;../include/OBA;D:\design_04_11_2005\svn\NonGTP\Boost"
+				AdditionalOptions="/D &quot;TIXML_USE_STL&quot; /D &quot;TIXML_USE_STL&quot; /D &quot;OBA_LIB_BUILD&quot;  /D &quot;IMG_LIB_BUILD&quot;"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;&quot;$(OGRE_PATH)/Samples/Common/include&quot;;../include/IMG;../include/BBC;../include/LBBC;../include/OBA;D:\design_04_11_2005\svn\NonGTP\Boost;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
 				RuntimeLibrary="2"
@@ -92,8 +92,8 @@
 				Name="VCLinkerTool"
 				AdditionalOptions=" /IMPLIB:&quot;..\bin\release\$(ProjectName).lib&quot; "
-				AdditionalDependencies="OgreMain.lib"
+				AdditionalDependencies="OgreMain.lib imdebug.lib"
 				LinkIncremental="1"
 				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)&quot;;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\lib"
 				SubSystem="1"
 				OptimizeReferences="2"
@@ -223,4 +223,10 @@
 				</File>
 				<File
+					RelativePath="..\src\LBBCClusterViewMode.cpp">
+				</File>
+				<File
+					RelativePath="..\src\LBBCEntityTextureAtlasViewMode.cpp">
+				</File>
+				<File
 					RelativePath="..\src\LBBCKdTreeClusterGenerator.cpp">
 				</File>
@@ -288,4 +294,10 @@
 				<File
 					RelativePath="..\src\IMGPlane3.cpp">
+				</File>
+				<File
+					RelativePath="..\src\IMGTexture.cpp">
+				</File>
+				<File
+					RelativePath="..\src\IMGTextureAtlas.cpp">
 				</File>
 			</Filter>
@@ -417,4 +429,7 @@
 				</File>
 				<File
+					RelativePath="..\include\Lbbc\LBBCEntityTextureAtlasViewMode.h">
+				</File>
+				<File
 					RelativePath="..\include\Lbbc\LBBCKdTreeClusterGenerator.h">
 				</File>
@@ -491,4 +506,10 @@
 				<File
 					RelativePath="..\include\Img\IMGPrerequisites.h">
+				</File>
+				<File
+					RelativePath="..\include\Img\IMGTexture.h">
+				</File>
+				<File
+					RelativePath="..\include\Img\IMGTextureAtlas.h">
 				</File>
 			</Filter>
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj	(revision 731)
@@ -20,5 +20,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="../include;../include/BBC;../include/IMG;../include/OBA;../include/LBBC;&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;D:\design_04_11_2005\svn\NonGTP\Boost"
+				AdditionalIncludeDirectories="../include;../include/BBC;../include/IMG;../include/OBA;../include/LBBC;&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;D:\design_04_11_2005\svn\NonGTP\Boost;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE"
 				MinimalRebuild="TRUE"
@@ -33,8 +33,8 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="IBRBillboardCloudTreeGenerator_d.lib OgreMain_d.lib"
+				AdditionalDependencies="IBRBillboardCloudTreeGenerator_d.lib OgreMain_d.lib imdebug.lib"
 				OutputFile="$(OutDir)/IBRBillboardCloudTreeGeneratorCmd_d.exe"
 				LinkIncremental="2"
-				AdditionalLibraryDirectories="../bin/$(ConfigurationName);$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				AdditionalLibraryDirectories="&quot;../bin/$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)/OgreMain/lib/Release&quot;;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\lib"
 				GenerateDebugInformation="TRUE"
 				ProgramDatabaseFile="$(OutDir)/scripts.pdb"
@@ -70,5 +70,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="../include;../include/OBA;../include/BBC;../include/IMG;../include/LBBC;&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;D:\design_04_11_2005\svn\NonGTP\Boost"
+				AdditionalIncludeDirectories="../include;../include/OBA;../include/BBC;../include/IMG;../include/LBBC;&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;D:\design_04_11_2005\svn\NonGTP\Boost;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
 				RuntimeLibrary="0"
@@ -81,8 +81,8 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="IBRBillboardCloudTreeGenerator.lib OgreMain.lib"
+				AdditionalDependencies="IBRBillboardCloudTreeGenerator.lib OgreMain.lib imdebug.lib"
 				OutputFile="$(OutDir)/IBRBillboardCloudTreeGeneratorCmd.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="../bin/$(ConfigurationName);$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				AdditionalLibraryDirectories="&quot;../bin/$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)&quot;;D:\design_04_11_2005\svn\NonGTP\ImageDebugger\lib"
 				GenerateDebugInformation="TRUE"
 				SubSystem="1"
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreFrameListener.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreFrameListener.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreFrameListener.cpp	(revision 731)
@@ -39,4 +39,8 @@
 OgreFrameListener::~OgreFrameListener()
 {
+		for (unsigned int iOgreFrameListenerMode = 0; iOgreFrameListenerMode < this->getNumFrameListenerModes(); iOgreFrameListenerMode++)
+		{
+			this->removeFrameListenerMode(iOgreFrameListenerMode);		
+		}
 		if (mInputTypeSwitchingOn)
 		{
@@ -48,16 +52,11 @@
         else
         {
-			if (mInputDevice)
-			{
-				Ogre::PlatformManager::getSingleton().destroyInputReader( mInputDevice );
-			}
+			// Gametools -- BUG: 06/04/2006
+			//if (mInputDevice)
+			//{
+			//	Ogre::PlatformManager::getSingleton().destroyInputReader( mInputDevice );
+			//}
+			//delete mInputDevice;
         }
-
-		for (unsigned int iOgreFrameListenerMode = 0; iOgreFrameListenerMode < this->getNumFrameListenerModes(); iOgreFrameListenerMode++)
-		{
-			OBA::OgreFrameListenerMode *ogreFrameListenerMode = this->getFrameListenerMode(iOgreFrameListenerMode);
-			this->removeFrameListenerMode(iOgreFrameListenerMode);
-			delete ogreFrameListenerMode;
-		}
 }
 
@@ -91,4 +90,6 @@
     }
 
+	mWindow->setDebugText("P: " + mDefaultOgreFrameListenerMode->getSceneManager()->getName() + " -- " + Ogre::StringConverter::toString(mTimeUntilNextToggle));
+
 	return mDefaultOgreFrameListenerMode->frameStarted(evt,mInputDevice);
 }
@@ -107,5 +108,5 @@
 		mWindow->setDebugText("P: " + mDefaultOgreFrameListenerMode->getSceneManager()->getName());
 
-		mTimeUntilNextToggle = 1;
+		mTimeUntilNextToggle = 0.25;
     }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreApplication.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreApplication.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreApplication.cpp	(revision 731)
@@ -14,8 +14,8 @@
 {
 	// Gametools -- BUG: 31/03/2006
-	//if (mFrameListener)
-	//{
-	//	delete mFrameListener;
-	//}
+	if (mFrameListener)
+	{
+		delete mFrameListener;
+	}
 
 	//if (mOgreBase)
@@ -76,6 +76,6 @@
 		// You can skip this and use root.restoreConfig() to load configuration
 		// settings if you were sure there are valid ones saved in ogre.cfg
-		//if(mRoot->showConfigDialog())
-		if (mRoot->restoreConfig())
+		if(mRoot->showConfigDialog())
+		//if (mRoot->restoreConfig())
 		{
 			// If returned true, user clicked OK so initialise
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCMesh.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCMesh.cpp	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCMesh.cpp	(revision 731)
@@ -0,0 +1,15 @@
+
+#include "BBCMesh.h"
+
+namespace BBC {
+
+
+Mesh::~Mesh()	 
+{
+	Ogre::LogManager::getSingleton().logMessage("Destroy Mesh...");
+	Ogre::MeshManager::getSingleton().unload( this->get()->getName() );
+	Ogre::MeshManager::getSingleton().remove( this->get()->getName() );
+	//delete mMesh;
+}
+
+}
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster2d.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster2d.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster2d.cpp	(revision 731)
@@ -13,15 +13,15 @@
 }
 
-Ogre::Vector2 * Cluster2d::GetVector3s()
+Ogre::Vector2 * Cluster2d::getVector3s()
 { 
 	return Vector3s; 
 }
 
-std::vector<Ogre::Vector2> * Cluster2d::GetVector3sVector() 
+std::vector<Ogre::Vector2> * Cluster2d::getVector3sVector() 
 { 
 	return &Vector3s2_vector; 
 } 
 
-Ogre::Vector3 * Cluster2d::GetNormal() 
+Ogre::Vector3 * Cluster2d::getNormal() 
 { 
 	return normal; 
@@ -31,5 +31,5 @@
 //			
 //	 
-int Cluster2d::Create2d(Cluster * cluster, int type, int type_vertexs) 
+int Cluster2d::create2d(Cluster * cluster, int type, int type_vertexs) 
 {
 	if (!cluster)
@@ -38,5 +38,5 @@
 	}
 	
-	int axis = cluster->AxisProjected();
+	int axis = cluster->axisProjected();
 
 	this->cluster = cluster;
@@ -45,7 +45,7 @@
 }
 
-void Cluster2d::Print() 
+void Cluster2d::print() 
 {
-	printf("\nPrintant cluster2d: %d", id);
+	Ogre::LogManager::getSingleton().logMessage("Printant cluster2d: " + Ogre::StringConverter::toString(id));
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCEntityTextureAtlasViewMode.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCEntityTextureAtlasViewMode.cpp	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCEntityTextureAtlasViewMode.cpp	(revision 731)
@@ -0,0 +1,171 @@
+
+#include "LBBCEntityTextureAtlasViewMode.h"
+
+namespace LBBC 
+{
+
+EntityTextureAtlasViewMode::EntityTextureAtlasViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys, bool useBufferedInputMouse)
+:OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
+{	
+	mTextureAtlasGenerated = false;
+	mFrame = 0;
+	mDebugOverlay->setScale(0.0, 0.0);
+}
+
+EntityTextureAtlasViewMode::~EntityTextureAtlasViewMode()
+{
+	// Gametools -- BUG: 06/04/2006
+	//destroyScene();
+}
+
+void EntityTextureAtlasViewMode::setTextureAtlasFolder(Ogre::String textureAtlasFolder)
+{
+	mTextureAtlasFolder = textureAtlasFolder;
+}
+
+void EntityTextureAtlasViewMode::setTextureName(Ogre::String textureName)
+{
+	mTextureName = textureName;
+}
+
+void EntityTextureAtlasViewMode::setTextureAtlasName(Ogre::String textureAtlasName)
+{
+	mTextureAtlasName = textureAtlasName;
+}
+
+void EntityTextureAtlasViewMode::setTextureAtlasSize(unsigned int size)
+{
+	mTextureAtlasSize = size;
+}
+
+void EntityTextureAtlasViewMode::setTextureAtlasNumSamples(unsigned int numSamples)
+{
+	mNumSamples = numSamples;
+}
+
+void EntityTextureAtlasViewMode::setTextureAtlasBitRange(unsigned int bitRange)
+{
+	mBitRange = bitRange;
+}
+
+unsigned int EntityTextureAtlasViewMode::nextPowerOf2(unsigned int nPlanes)
+{
+	unsigned int depth = 1;
+	while (depth < nPlanes)
+	{
+		depth = depth << 1;
+	}
+	return depth;
+}
+
+bool EntityTextureAtlasViewMode::frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader)
+{
+	if (mFrame == 1)
+	{
+		if (!mTextureAtlasGenerated)
+		{
+			if (mBitRange == 32)
+			{
+				mDestPixelFormat = Ogre::PF_FLOAT32_RGBA;
+			}
+			else if (mBitRange == 16)
+			{
+				mDestPixelFormat = Ogre::PF_FLOAT16_RGBA;
+			}
+			else  // mBitRange == 8
+			{
+				mDestPixelFormat = Ogre::PF_A8R8G8B8;
+			}
+
+			mTextureAtlas->update();
+			mTextureAtlas->save(mTextureAtlasFolder, mTextureAtlasName, mDestPixelFormat);
+			mTextureAtlasGenerated = true;
+		}
+	}
+
+	mFrame++;
+
+	return OgreFrameListenerMode::frameStarted(evt, inputReader);	
+}
+
+
+void EntityTextureAtlasViewMode::createScene()
+{
+	mTextureAtlasNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
+	mTextureAtlas = IMG::TextureAtlasPtr( new IMG::TextureAtlas() );
+
+	if (mBitRange == 32)
+	{
+		mSrcPixelFormat = Ogre::PF_FLOAT32_RGBA;
+	}
+	else if (mBitRange == 16)
+	{
+		mSrcPixelFormat = Ogre::PF_FLOAT16_RGBA;
+	}
+	else  // mBitRange == 8
+	{
+		mSrcPixelFormat = Ogre::PF_A8R8G8B8;
+	}
+
+	mTextureAtlas->create(mTextureAtlasName, mTextureAtlasSize, mTextureAtlasSize, mSrcPixelFormat, mCamera);
+	mTextureAtlas->setTextureAtlasSceneNode(mTextureAtlasNode);
+
+	unsigned int numSubTextures = mNumSamples;			
+	Ogre::Vector2 maxTexCoords(1.0, 1.0);
+	unsigned int irow = 1;
+	unsigned int icol = 1;
+	unsigned int nrow = Ogre::Math::Sqrt(nextPowerOf2(numSubTextures));
+	Ogre::Real step = 2.0 / nrow;
+	Ogre::Real degreeStep = 360.0 / numSubTextures;
+	Ogre::Real degree = 0.0;
+
+	IMG::TexturePtr texturePtr ( new IMG::Texture() );
+	texturePtr->bind(mTextureName);
+	Ogre::MaterialPtr materialPtr = Ogre::MaterialManager::getSingleton().create("TextureAtlas" + Ogre::StringConverter::toString(numSubTextures), "General");		
+	materialPtr->getTechnique(0)->getPass(0)->setDiffuse( 1.0, 1.0, 1.0, 0.0);
+	materialPtr->getTechnique(0)->getPass(0)->setAmbient( texturePtr->getAvgColour() );	
+
+	mTextureAtlas->setMaterial(materialPtr.getPointer());	
+	mTextureAtlas->setCorners(-1.0, 1.0, 1.0, -1.0);	
+
+	for (unsigned int iSubTexture = 0; iSubTexture < numSubTextures; iSubTexture++)
+	{				
+		IMG::TexturePtr texturePtr = IMG::TexturePtr( new IMG::Texture() );
+		Ogre::MaterialPtr materialPtr = Ogre::MaterialManager::getSingleton().create("TextureAtlas" + Ogre::StringConverter::toString(iSubTexture), "General");		
+		materialPtr->getTechnique(0)->getPass(0)->setAmbient( 1.0, Ogre::Math::RangeRandom(0.5,1.0), 1.0 );
+		materialPtr->getTechnique(0)->getPass(0)->setAmbient(maxTexCoords[0], maxTexCoords[1], 1.0 );
+		materialPtr->getTechnique(0)->getPass(0)->setDiffuse( 1.0, 1.0, 1.0, 1.0);
+		materialPtr->getTechnique(0)->getPass(0)->setAlphaRejectSettings(Ogre::CMPF_GREATER_EQUAL, 10);
+		materialPtr->getTechnique(0)->getPass(0)->createTextureUnitState(mTextureName, 0);
+		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureAddressingMode(Ogre::TextureUnitState::TAM_CLAMP);
+		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureRotate(Ogre::Radian(Ogre::Degree(degree)));
+		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureFiltering(Ogre::FO_NONE, Ogre::FO_NONE, Ogre::FO_NONE);
+		materialPtr->getTechnique(0)->getPass(0)->setLightingEnabled(false);
+		
+		texturePtr->setMaterial(materialPtr.getPointer());
+		texturePtr->setCorners(maxTexCoords[0] - step, maxTexCoords[1], maxTexCoords[0], maxTexCoords[1] - step);
+	
+		mTextureAtlas->addTexture(texturePtr);
+
+		if (irow == nrow)
+		{
+			irow = 1;
+			icol++;
+			maxTexCoords = Ogre::Vector2(1.0, maxTexCoords[1] - step);
+		}
+		else
+		{
+			irow++;
+			maxTexCoords = Ogre::Vector2(maxTexCoords[0] - step, maxTexCoords[1]);
+		}
+
+		degree = degree + degreeStep;
+	}
+}
+
+void EntityTextureAtlasViewMode::destroyScene()
+{
+	mTextureAtlasNode->detachAllObjects();
+}
+
+}
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreBase.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreBase.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreBase.cpp	(revision 731)
@@ -29,13 +29,13 @@
 	return mXMLMeshSerializer;
 }
-	
+
+Ogre::MaterialSerializer* OgreBase::getMaterialSerializer()
+{
+	return mMaterialSerializer;
+}
+
 Ogre::MeshSerializer* OgreBase::getMeshSerializer()
 {
 	return mMeshSerializer;
-}
-
-Ogre::MeshManager* OgreBase::getMeshManager()
-{
-	return mMeshManager;
 }
 
@@ -48,5 +48,7 @@
    mMath = new Ogre::Math();
    mMeshManager = new Ogre::MeshManager();
-   //mMaterialManager = new Ogre::MaterialManager();
+   mMaterialManager = new Ogre::MaterialManager();
+   mMaterialManager->initialise();
+   mMaterialSerializer = new Ogre::MaterialSerializer();
    mMeshSerializer = new Ogre::MeshSerializer();
    mXMLMeshSerializer = new Ogre::XMLMeshSerializer();
@@ -79,4 +81,9 @@
 	}
 
+	if (mMaterialSerializer)
+	{
+		delete mMaterialSerializer;
+	}
+
 	if (mMath)
 	{
@@ -89,9 +96,9 @@
 	}
 
-	//if (mMaterialManager)
-	//{
-	//	mMaterialManager->removeAll();
-	//	delete mMaterialManager;	
-	//}
+	if (mMaterialManager)
+	{
+		mMaterialManager->removeAll();
+		delete mMaterialManager;	
+	}
 
 	if (mResourceGroupManager)
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCOgreMeshSerializer.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCOgreMeshSerializer.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCOgreMeshSerializer.cpp	(revision 731)
@@ -53,5 +53,5 @@
 		BBC::MeshPtr pMesh(new BBC::Mesh(Ogre::MeshManager::getSingleton().createManual(fileName, fileName).getPointer()));
 		
-		Ogre::MeshPtr mesh = OBA::OgreBase::getSingleton().getMeshManager()->load(fileName, fileName);
+		Ogre::MeshPtr mesh = Ogre::MeshManager::getSingleton().load(fileName, fileName);
 
 		Ogre::LogManager::getSingleton().logMessage("Num.SubEntities:" + Ogre::StringConverter::toString(mEntity->getNumSubEntities()));
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGPlane3.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGPlane3.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGPlane3.cpp	(revision 731)
@@ -21,5 +21,5 @@
 }
 
-Ogre::Vector3 * Plane3::GetNormal() 
+Ogre::Vector3 * Plane3::getNormal() 
 {
 	Ogre::Vector3 *v = new Ogre::Vector3;
@@ -30,5 +30,5 @@
 }
 
-void Plane3::SetNormal(float x, float y, float z) 
+void Plane3::setNormal(float x, float y, float z) 
 {
     normal.x = x;
@@ -37,15 +37,15 @@
 }
 
-void Plane3::SetDistance(float dist) 
+void Plane3::setDistance(float dist) 
 {
     d = dist;
 }
 
-float Plane3::GetDistance() const 
+float Plane3::getDistance() const 
 { 
 	return d;
 }
 
-void Plane3::Print() 
+void Plane3::print() 
 {
 	Ogre::LogManager::getSingleton().logMessage("Printant pla: (" + Ogre::StringConverter::toString(normal) + Ogre::StringConverter::toString(d) + ")");
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBsp.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBsp.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBsp.cpp	(revision 731)
@@ -14,5 +14,5 @@
 }
 
-void Bsp::SetRoot(NodeBspPtr node) 
+void Bsp::setRoot(NodeBspPtr node) 
 {
     root = node;
@@ -20,22 +20,22 @@
 }
 
-void Bsp::Print() 
+void Bsp::print() 
 {
 	Ogre::LogManager::getSingleton().logMessage("\nImprimint Arbre BSP, num nodes leaf: " + Ogre::StringConverter::toString(countleaf) + ", totals: " + Ogre::StringConverter::toString(counttotal));
-    Print(root);
+    print(root);
 }
 
-void Bsp::PrintLeaf()
+void Bsp::printLeaf()
 {
-  	PrintLeaf(root);
+  	printLeaf(root);
 }
 
-NodeBspPtr Bsp::Insert(int w, int h, int idcluster) 
+NodeBspPtr Bsp::insert(int w, int h, int idcluster) 
 {
-    NodeBspPtr node = root->Insert(w,h);
+    NodeBspPtr node = root->insert(w,h);
 
 	if (idcluster != -1)
     {
-    	node->SetId (idcluster);
+    	node->setId(idcluster);
     	countleaf++;			
     }
@@ -48,25 +48,25 @@
 }
 
-NodeBspPtr Bsp::Get(int i) 
+NodeBspPtr Bsp::get(int i) 
 {
-	return root->Get(root, i);
+	return root->get(root, i);
 }
 
-void Bsp::Print(NodeBspPtr node) 
+void Bsp::print(NodeBspPtr node) 
 {
-    node->Print();
-    Print(node->GetChild(0));
-    Print(node->GetChild(1));
+    node->print();
+    this->print(node->getChild(0));
+    this->print(node->getChild(1));
 }
 
-void Bsp::PrintLeaf(NodeBspPtr node) 
+void Bsp::printLeaf(NodeBspPtr node) 
 {   	
-    if (node->GetChild(0) == NULL && node->GetChild(1) == NULL)
+    if (node->getChild(0) == NULL && node->getChild(1) == NULL)
 	{
-		node->Print();
+		node->print();
 	}
     	
-    PrintLeaf (node->GetChild(0));
-    PrintLeaf (node->GetChild(1));	
+    printLeaf(node->getChild(0));
+    printLeaf(node->getChild(1));	
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IBRBillboardCloudTreeApplication.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IBRBillboardCloudTreeApplication.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IBRBillboardCloudTreeApplication.cpp	(revision 731)
@@ -19,9 +19,10 @@
 	for (unsigned int i = 0; i < 1; i++)
 	{
+		mSampleConfigFile = new LBBC::SampleConfigFile();
+		mSampleConfigFile->load(mOpts.cfg);
+
 		this->setup(false);
-		mLBBCManager = new LBBC::Manager();	
-		LBBC::SampleConfigFile *sampleConfigFile = new LBBC::SampleConfigFile();
-		sampleConfigFile->load(mOpts.cfg);
-		mLBBCManager->setSampleConfigFile(sampleConfigFile);	
+		mLBBCManager = new LBBC::LBBCManager();	
+		mLBBCManager->setSampleConfigFile(mSampleConfigFile);	
 		//mLBBCManager->loadSampleConfigFile(mOpts.cfg);
 		mLBBCManager->runSampleConfigFile();	
@@ -33,8 +34,14 @@
 		this->setup(true);
 		this->go();	
+		for (unsigned int iFrameListenerMode = 0; iFrameListenerMode < mFrameListener->getNumFrameListenerModes(); iFrameListenerMode++)
+		{
+			mFrameListener->getFrameListenerMode(iFrameListenerMode)->destroyScene();
+		}
 		mRoot->shutdown();	
 		mWindow->destroy();		
 		delete mRoot;
+		delete mSampleConfigFile;
 	}
+
 }
 
@@ -108,7 +115,8 @@
 	
 	mSceneMgr = mFrameListener->getEnabledFrameListenerMode()->getSceneManager();	
+
 	{
-		LBBC::ClustersViewMode *anotherFrameListenerMode;
-		anotherFrameListenerMode = new LBBC::ClustersViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
+		LBBC::ClusterViewMode *anotherFrameListenerMode;
+		anotherFrameListenerMode = new LBBC::ClusterViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
 		anotherFrameListenerMode->chooseSceneManager();
 		anotherFrameListenerMode->createCamera();
@@ -118,16 +126,33 @@
 	}
 
+	//{
+	//	LBBC::BillboardViewMode *anotherFrameListenerMode;
+	//	anotherFrameListenerMode = new LBBC::BillboardViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
+	//	anotherFrameListenerMode->chooseSceneManager();
+	//	anotherFrameListenerMode->createCamera();
+	//	anotherFrameListenerMode->createViewports();
+	//	anotherFrameListenerMode->createScene();
+	//	mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
+	//}
+
 	{
-		LBBC::BillboardViewMode *anotherFrameListenerMode;
-		anotherFrameListenerMode = new LBBC::BillboardViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
-		anotherFrameListenerMode->chooseSceneManager();
-		anotherFrameListenerMode->createCamera();
-		anotherFrameListenerMode->createViewports();
-		anotherFrameListenerMode->createScene();
-		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
+		LBBC::EntityTextureAtlasViewMode *textureAtlasFrameListenerMode;
+		textureAtlasFrameListenerMode = new LBBC::EntityTextureAtlasViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
+		textureAtlasFrameListenerMode->chooseSceneManager();
+		textureAtlasFrameListenerMode->createCamera();
+		textureAtlasFrameListenerMode->createViewports();
+		textureAtlasFrameListenerMode->setTextureAtlasSize(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasSize());
+		textureAtlasFrameListenerMode->setTextureAtlasBitRange(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasBitRange());
+		textureAtlasFrameListenerMode->setTextureAtlasNumSamples(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples());
+		textureAtlasFrameListenerMode->setTextureName(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTexturePrefixName());
+		textureAtlasFrameListenerMode->setTextureAtlasName(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureAtlasPrefixName());
+		textureAtlasFrameListenerMode->setTextureAtlasFolder(mSampleConfigFile->getBillboardCloudFolder());
+
+		mFrameListener->addFrameListenerMode(textureAtlasFrameListenerMode);
+		textureAtlasFrameListenerMode->createScene();
 	}
 
-	mFrameListener->setEnabledFrameListenerMode(1);
 	mFrameListener->removeFrameListenerMode(0);
+	mFrameListener->setEnabledFrameListenerMode(0);
 
     mRoot->addFrameListener(mFrameListener);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGNodeBsp.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGNodeBsp.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGNodeBsp.cpp	(revision 731)
@@ -15,30 +15,30 @@
 }
 
-void NodeBsp::SetBound(Box2d * box) 
+void NodeBsp::setBound(Box2d * box) 
 { 
 	bound = (*box); 
 }
 
-NodeBspPtr NodeBsp::GetChild(int i) 
+NodeBspPtr NodeBsp::getChild(int i) 
 { 
 	return child[i]; 
 }
 
-void NodeBsp::SetId(int id_) 
+void NodeBsp::setId(int id_) 
 { 
 	id = id_; 
 }
 
-unsigned int NodeBsp::GetId() const
+unsigned int NodeBsp::getId() const
 { 
 	return id; 
 }
 
-void NodeBsp::SetChild(NodeBspPtr node, int i) 
+void NodeBsp::setChild(NodeBspPtr node, int i) 
 { 
 	child[i] = node; 
 }
 
-NodeBspPtr NodeBsp::Get(NodeBspPtr node, int i) 
+NodeBspPtr NodeBsp::get(NodeBspPtr node, int i) 
 {
     if (!node)
@@ -47,5 +47,5 @@
 	}
 
-    if (node->GetId() == i )
+    if (node->getId() == i )
 	{
 		return node;
@@ -53,26 +53,26 @@
     
     NodeBspPtr nod; 
-    if (nod = node->GetChild(0)->Get(node->GetChild(0), i)) 
+    if (nod = node->getChild(0)->get(node->getChild(0), i)) 
 	{
 		return nod;
 	}
     
-    return node->GetChild(0)->Get(node->GetChild(1), i);
+    return node->getChild(0)->get(node->getChild(1), i);
 }
 
 
-Box2d * NodeBsp::GetBound() 
+Box2d * NodeBsp::getBound() 
 { 
 	return &bound;   
 }
 
-void NodeBsp::Print() 
+void NodeBsp::print() 
 {
 	Ogre::LogManager::getSingleton().logMessage("Node : " + Ogre::StringConverter::toString(id) + ", fit: " + Ogre::StringConverter::toString(fit));
 
-	bound.Print();
+	bound.print();
 }
 
-NodeBspPtr NodeBsp::Insert(int w, int h) 
+NodeBspPtr NodeBsp::insert(int w, int h) 
 {
 	//Ogre::LogManager::getSingleton().logMessage("\nInsert del node: :" + Ogre::StringConverter::toString(id) + " (" + Ogre::StringConverter::toString(w) + ", " + Ogre::StringConverter::toString(h));
@@ -85,17 +85,17 @@
 	if (this->child[0] != NULL && this->child[1] != NULL)
 	{
-		NodeBspPtr new_node = child[0]->Insert(w, h);
+		NodeBspPtr new_node = child[0]->insert(w, h);
 		
 		if (new_node) return new_node;
 		
-		return child[1]->Insert(w,h);
+		return child[1]->insert(w,h);
 	}
 	
-	if (!bound.In (w,h)) 
+	if (!bound.in(w,h)) 
 	{
 		return NULL; 
 	}
 	
-	if (bound.FitPerfect(w,h))
+	if (bound.fitPerfect(w,h))
 	{
 		fit = true;  return this; 
@@ -109,7 +109,7 @@
 	float width, height;
 	
-	bound.Print();
-	min = bound.GetMinimum();
-	max = bound.GetMaximum();
+	bound.print();
+	min = bound.getMinimum();
+	max = bound.getMaximum();
 	
 	width = max.x - min.x;
@@ -121,14 +121,14 @@
 	if (dw > dh)
 	{	
-		child[0]->bound.SetBoundBox(min.x, min.y, min.x + w, max.y);		
-		child[1]->bound.SetBoundBox(min.x + w, min.y, max.x, max.y);										
+		child[0]->bound.setBoundBox(min.x, min.y, min.x + w, max.y);		
+		child[1]->bound.setBoundBox(min.x + w, min.y, max.x, max.y);										
 	}
 	else
 	{		
-		child[0]->bound.SetBoundBox(min.x, max.y - h, max.x, max.y);
-		child[1]->bound.SetBoundBox(min.x, min.y, max.x, max.y - h);
+		child[0]->bound.setBoundBox(min.x, max.y - h, max.x, max.y);
+		child[1]->bound.setBoundBox(min.x, min.y, max.x, max.y - h);
 	}
 	
-	return child[0]->Insert(w, h);
+	return child[0]->insert(w, h);
 }
 
